#ifndef FUNCTIONS_STRCOPY
#define FUNCTIONS_STRCOPY

#ifndef COPY_ALL
#define COPY_ALL 0x7fffffff
#endif

static LONG StrCopy(STRING String, STRING Dest, LONG Length)
{
   LONG i;

   if (Length < 1) return(0);

   i = 0;
   if ((String) AND (Dest)) {
      while ((i < Length) AND (*String)) Dest[i++] = *String++;

      if ((*String) AND (i >= Length)) {
         Dest[i-1] = 0; /* If we ran out of buffer space, we have to terminate from one character back */
      }
      else Dest[i] = 0;
   }

   return(i);
}

#endif /* FUNCTIONS_STRCOPY */
